;;; ----------------------------------------------------------------------
;;; ١ for Z80
;;;   S.Kamio
;;; $Id: invader.S,v 1.12 2000/12/02 02:47:23 skamio Exp $
;;; ----------------------------------------------------------------------
	
	ORG 8000h
	JP start
	
#include "stdio.S"
#include "esc_seq.h"
#include "util.S"
	
#define SCREEN_WIDTH	40
#define SCREEN_HEIGHT	22
#define INVADER_TYPES	3	/* Ũμ */
#define BASE_POINT	10	/* δ */
#define RANKING_NAME_LEN 9	/* 󥭥󥰤̾Ĺ */
		
#define NULL	0h
	
;;; ----------------------------------------------------------------------
;;; start
;;; ----------------------------------------------------------------------
	
start:
	;; Ȳ
	LD HL, SCREEN_START_STRING
	call puts
#ifndef _EMU_
	LD B, 3
	call wait_sec
#endif
	LD HL, SCREEN_CLEAR_STRING
	call puts
	
game_start:
	;; 롼
	call game_main
	
	;; λ
	LD HL, LOSER_MESSAGE
	call puts

	;;    2
	LD B, 2
	call wait_sec
		
	;; ranking
	call ranking

	call display_ranking

	LD HL, MSG_PUSH_ANY_KEY
	call puts
	;; Ԥ
	call getchar

	JP start

MSG_PUSH_ANY_KEY:
	DB POS('25','20')
	DB "push any key"
	
;;; ----------------------------------------------------------------------
;;; ʬ
;;;   餱ޤǽʤ롼
;;; ----------------------------------------------------------------------
#define INVADER_NUM	10		/* ¤ֿ */
#define INVADER_WIDTH	INVADER_NUM*2-1	/*  (ǸΥ١ޤ) */

#define INVADER_BASE_TIMING	12 /* 0.6sec */
#define SHOT_TIMING	3 /* 0.2sec */
	
game_main:
	;; ------------------------------------------------------------
	;; 
	;; ------------------------------------------------------------
	
	;; 
new_game:	
	XOR A
	LD (INVADER_LEVEL), A
	LD (CURRENT_POINT), A
	LD (CURRENT_POINT+1), A

	;;  & ³
GAME_MAIN_NEXT_LEVEL:
	;; ٥
	LD A, (INVADER_LEVEL)
	INC A
	LD (INVADER_LEVEL), A
	;;   ٤
	SLA A
	SUB INVADER_BASE_TIMING
	NEG			; (12 - LEVEL*2) * 0.05sec 餤
	LD (INVADER_TIMING), A
	
	;;   ١
	;;    INVADERS_LINES INVADER_WIDTH INVADER_TYPES
	
	LD C, INVADER_TYPES
	LD HL, INVADERS_LINES	; ١ʬ
	LD DE, INVADERS_CHAR	; ١ʸ
GAME_MAIN_INVADER_INIT_LOOP:
	;;   1ˤĤ
	LD A, (DE)		; ١ʸ
	PUSH DE			; ١ʸݥ
	LD D, A
	LD E, 20h		; 
	LD B, INVADER_NUM-1
GAME_MAIN_INVADER_INIT_INNERLOOP:
	LD (HL), D		; ١ʸ
	INC HL
	LD (HL), E		; 
	INC HL
	DJNZ GAME_MAIN_INVADER_INIT_INNERLOOP

	LD (HL), D		; Ǹ
	INC HL
	
	POP DE
	INC DE
	DEC C
	JR NZ, GAME_MAIN_INVADER_INIT_LOOP

	;; ٤褵뤿
	LD A, 1
	LD (INVADER_TIMER), A
	LD (SHOT_TIMER), A
	;; ѿ
	XOR A
	LD (INVADER_X), A
	INC A
	INC A			; ̤ξ2ԤѤ
	LD (INVADER_Y), A
	LD A, -1
	LD (SHOT_Y), A

	call display_point
	call move_cannon_draw	
	;; ------------------------------------------------------------
	;; 롼
	;; ------------------------------------------------------------
GAME_MAIN_LOOP:	
#ifndef _EMU_
	LD BC, 15000	/* ֤ */
GAME_MAIN_IDLE_LOOP:	
	NOP
	DEC BC
	LD A, B
	OR C			; BC == 0?
	JR NZ, GAME_MAIN_IDLE_LOOP
	;; 1롼פ30ơ
#endif
	
GAME_MAIN_MOVE_SHOT:	
	;; ƴݥߥ
	LD A, (SHOT_TIMER)
	DEC A
	LD (SHOT_TIMER), A
	JR NZ, GAME_MAIN_MOVE_INVADER
	LD A, SHOT_TIMING
	LD (SHOT_TIMER), A
	call move_shot
	
GAME_MAIN_MOVE_INVADER:	
	;; ١ߥ
	LD A, (INVADER_TIMER)
	DEC A
	LD (INVADER_TIMER), A
	JR NZ, GAME_MAIN_MOVE_CANNON
	LD A, (INVADER_TIMING)	; ߥ󥰥ꥻå
	LD (INVADER_TIMER), A
	call move_invader	

GAME_MAIN_MOVE_CANNON:	
	;; ˤΰư
	call move_cannon
	
	;; Ƚ
	call check_crash
	RET C			; 	
	;; ޤǤϥ롼
	JR NZ, GAME_MAIN_LOOP
	
	;; Ǥ Zero = 1
	
	JP GAME_MAIN_NEXT_LEVEL

;;; ----------------------------------------------------------------------
;;; move_invader
;;;   ١ΰư
;;; ----------------------------------------------------------------------
move_invader:	
	;; ޤõ
	XOR A
	call move_invader_draw
	
	;; ư INVADER_Yκǲ̥ӥåȤǷ
	LD A, (INVADER_Y)
	AND 1h
	LD A, (INVADER_X)
	JR Z, MOVE_INVADER_RIGHT
MOVE_INVADER_LEFT:
	DEC A
	JP P, MOVE_INVADER_LR
	XOR A
	LD HL, INVADER_Y
	INC (HL)
	JR MOVE_INVADER_LR
	
MOVE_INVADER_RIGHT:
	INC A
	CP SCREEN_WIDTH-INVADER_WIDTH
	JR C, MOVE_INVADER_LR
	DEC A
	LD HL, INVADER_Y
	INC (HL)
	
MOVE_INVADER_LR:	
	LD (INVADER_X), A
	
	;; 
	INC A
	call move_invader_draw
	
	RET
;;; ----------------------------------------------------------------------
;;; move_invader_draw
;;;   ١ õˤȤ
;;;  A 쥸 = 0 õ !0 
;;; ----------------------------------------------------------------------
move_invader_draw:
	;; ------------------------------------------------------------
	;; 褫õ̿ʥߥå˽񤭴뤳Ȥؤ
	;; ------------------------------------------------------------
	
	;; 褫õ
	AND A
	JR NZ, MOVE_INVADER_DRAW_DAYNAMIC_WRITE

	;; ̿ʥߥå˽񤭴
	;; õλˤ
	LD B, MOVE_INVADER_DRAW_DYNAMIC_INSTRUCTION_END - MOVE_INVADER_DRAW_DYNAMIC_INSTRUCTION
	LD HL, MOVE_INVADER_DRAW_DYNAMIC	; ɸ
MOVE_INVADER_DRAW_DYNAMIC_CLEAR_LOOP:	
	LD (HL), A		; NOP
	INC HL
	DJNZ MOVE_INVADER_DRAW_DYNAMIC_CLEAR_LOOP
	;; 
	LD HL, DEFAULT_SCREEN_ERASE_COLOR
	call puts
	JR MOVE_INVADER_DRAW_START
	
	;; ̿ʥߥå˽񤭴
	;; λ
MOVE_INVADER_DRAW_DAYNAMIC_WRITE:
	LD BC, MOVE_INVADER_DRAW_DYNAMIC_INSTRUCTION_END - MOVE_INVADER_DRAW_DYNAMIC_INSTRUCTION
	LD DE, MOVE_INVADER_DRAW_DYNAMIC	; ɸ
	LD HL, MOVE_INVADER_DRAW_DYNAMIC_INSTRUCTION	; 
MOVE_INVADER_DRAW_DAYNAMIC_WRITE_LOOP:
	LDIR			; ֥åԡ

	;; ------------------------------------------------------------
	;; 賫
	;; ------------------------------------------------------------
MOVE_INVADER_DRAW_START:	
	LD A, (INVADER_Y)
	PUSH AF			; åYɸ
	
	LD C, INVADER_TYPES
	LD HL, INVADERS_LINES
	LD DE, INVADERS_COLOR
	;; 쥸
MOVE_INVADER_DRAW_MAIN:	
	;; ɸ
	POP AF			; Yɸ
	INC A
	INC A			; Yɸ += 2 (Ф)
	PUSH AF			; åYɸ
	PUSH BC			; ˲ʤ褦
	PUSH DE
	PUSH HL
	LD E, A
	LD A, (INVADER_X)
	LD D, A
	call set_pos
	POP HL
	POP DE
	POP BC

	;; 
	EX DE, HL		; DE = INVADER_LINES + x
				; HL = INVADER_COLOR + x
	PUSH DE			; åINVADERS_LINES
	LD E, (HL)
	INC HL
	LD D, (HL)
	INC HL
	EX DE, HL		; HL = ʸΥɥ쥹
				; DE = ʸΥݥ
MOVE_INVADER_DRAW_DYNAMIC:	
	call puts		; ʥߥå񤭴 check
				; õλˤɽؿƤФʤ
	
	POP HL			; HL = INVADERS_LINES + x
	
	;; ١
	LD B, INVADER_WIDTH
MOVE_INVADER_DRAW_LINE:		
	LD A, (HL)
	CP 20h			; ١뤫
	JR NZ, MOVE_INVADER_DRAW_LINE_EXIST

	PUSH HL
	LD HL, CURSOR_MOVE_RIGHT	; 1ıư
	call puts
	POP HL
	JR MOVE_INVADER_DRAW_LINE_NEXT
MOVE_INVADER_DRAW_LINE_EXIST:
	call putchar			;  or õ
MOVE_INVADER_DRAW_LINE_NEXT:
	INC HL
	DJNZ MOVE_INVADER_DRAW_LINE
	
	DEC C
	JR NZ, MOVE_INVADER_DRAW_MAIN
	POP AF			; Yɸ ˴ ե饰Ѥ뤫餳
	RET

	;; ------------------------------------------------------------
	;; ʥߥå񤭴ѥǡ
	;; ------------------------------------------------------------
MOVE_INVADER_DRAW_DYNAMIC_INSTRUCTION:
	call puts
MOVE_INVADER_DRAW_DYNAMIC_INSTRUCTION_END:	
	
;;; ----------------------------------------------------------------------
;;; move_shot
;;;   ƴݤΰư
;;; ----------------------------------------------------------------------
move_shot:
	LD A, (SHOT_Y)
	AND A
	RET M			; ̳

	;; õ
	LD HL, DEFAULT_SCREEN_ERASE_COLOR
	call puts
	LD A, (SHOT_Y)
	LD E, A
	LD A, (SHOT_X)
	LD D, A
	call set_pos
	LD A, 20h
	call putchar

	LD A, (SHOT_Y)
	DEC A
	CP 1			; 2Ԥ
	JR NZ, _MOVE_SHOT_SAVE_Y
	XOR A			; ̳
	DEC A
_MOVE_SHOT_SAVE_Y:	
	LD (SHOT_Y), A
	AND A
	RET M

	;; 
	LD E, A
	LD A, (SHOT_X)
	LD D, A
	call set_pos
	LD HL, SHOT_CHAR
	call puts
	
	RET

;;; ----------------------------------------------------------------------
;;; move_cannon
;;;   ϤϤǽʬ
;;; ----------------------------------------------------------------------
move_cannon:
	;; ------------------------------------------------------------
	;; ư
	;; ------------------------------------------------------------
	call getchar_nowait
	;; 
	RET Z			; ʤä
#ifdef _EMU_
	CP 1Bh			; (UNIX)
#else
	CP E0h			; üʥ
#endif
	JR NZ, MOVE_CANNON_KEY_CMP
#ifdef _EMU_  /* (UNIX) 5Bh ˴ */
	call getchar
#endif
	call getchar		; ΤȤ
MOVE_CANNON_KEY_CMP:	
	CP 20h			; ƴȯ
	JR Z, MOVE_CANNON_SHOT
	CP KEY_LEFT
	JR Z, MOVE_CANNON_MOVE_LEFT
	CP KEY_RIGHT
	JR Z, MOVE_CANNON_MOVE_RIGHT
	RET			; ʤǤʤϤΤޤ֤
	
MOVE_CANNON_MOVE_LEFT:
	LD A, (CANNON_X)
	AND A
	RET Z
	DEC A
	LD (MOVE_CANNON_REAL_MOVE+1), A	; ưXɸ ʥߥå񤭴
	JR MOVE_CANNON_CLEAR
	
MOVE_CANNON_MOVE_RIGHT:
	LD A, (CANNON_X)
	CP SCREEN_WIDTH-1-3	; ˤΥ
	RET Z
	INC A
	LD (MOVE_CANNON_REAL_MOVE+1), A	; ưXɸ ʥߥå˽񤭴 
	JR MOVE_CANNON_CLEAR
	
MOVE_CANNON_SHOT:		; ƴȯ
	;; ƴݤƱ1Ĥޤ
	;;   ȯͤǤ뤫
	LD A, (SHOT_Y)
	AND A
	RET P
	LD A, (CANNON_X)
	INC A			; ˤΥˤ
	LD (SHOT_X), A
	LD A, SCREEN_HEIGHT-2
	LD (SHOT_Y), A
	LD A, 1
	LD (SHOT_TIMER), A
	RET	

MOVE_CANNON_CLEAR:	
	;; ------------------------------------------------------------
	;; õ
	;; ------------------------------------------------------------
	LD HL, DEFAULT_SCREEN_ERASE_COLOR
	call puts
	
	LD A, (CANNON_X)
	LD D, A
	LD E, SCREEN_HEIGHT-2
	call set_pos
	LD HL, CANNON_ERASE_LINE1
	call puts
	
	LD A, (CANNON_X)
	LD D, A
	LD E, SCREEN_HEIGHT-1
	call set_pos
	LD HL, CANNON_ERASE_LINE2
	call puts

MOVE_CANNON_REAL_MOVE:	
	;; ư
	LD A, 0			; ưXɸ ʥߥå˽񤭴
	LD (CANNON_X), A
		
	;; ------------------------------------------------------------
	;; 
	;; ------------------------------------------------------------
MOVE_CANNON_DRAW:	
	LD A, (CANNON_X)
	LD D, A
	LD E, SCREEN_HEIGHT-2
	call set_pos
	LD HL, CANNON_LINE1_COLOR
	call puts
	
	LD A, (CANNON_X)
	LD D, A
	LD E, SCREEN_HEIGHT-1
	call set_pos
	LD HL, CANNON_LINE2
	call puts
	
	RET

;;; ----------------------------------------------------------------------
;;; check_crash
;;;   Ƚ
;;;   ץ졼䡼餱ʤ Carry = 1
;;;   ŨǤ Carry = 0, Zero = 1
;;;   Ǥʤ  Carry = 0, Zero = 0
;;; ----------------------------------------------------------------------
check_crash:
	;; ١˹ޤ줿
	call check_player_lose
	RET C

	;; ١ƴݤȽ
	LD A, (SHOT_Y)
	AND A
	JP M, CRASH_CHECK_NOMATTER
	call check_crash_shot
	
CHECK_CRASH_INVADER_COUNT:	
	;; Ũο
	LD B, INVADER_TYPES
	LD HL, INVADERS_LINES
CHECK_CRASH_INVADER_COUNT_LOOP:	
	LD C, INVADER_WIDTH
CHECK_CRASH_INVADER_COUNT_INNER:	
	LD A, (HL)
	CP 20h
	JR NZ, CRASH_CHECK_NOMATTER
	DEC C
	INC HL
	JR NZ, CHECK_CRASH_INVADER_COUNT_INNER
	DJNZ CHECK_CRASH_INVADER_COUNT_LOOP
	;; Carry = 0
	SCF
	CCF
	XOR A
	RET Z			;  RET

CRASH_CHECK_NOMATTER:	
	;; Ǥʤ
	;; Carry = 0, Zero = 0
	SCF
	CCF
	LD A, 1
	AND A
	RET

;;; ----------------------------------------------------------------------
;;; check_player_lose
;;;    ץ쥤䡼फ
;;;  Carry:	C 桼餱
;;;			NC ʤǤʤ
;;; ----------------------------------------------------------------------
check_player_lose:
	;;   ١Τå
	LD A, (INVADER_Y)
	LD D, A			; D = ١Yɸ
	LD B, INVADER_TYPES	; B = ١μ
	LD E, SCREEN_HEIGHT-4	; E = ̹⤵-4 ƬYɸ
	LD HL, INVADERS_LINES	; HL = ١Ƭ
CHECK_PLAYER_LOSE_LOOP:
	LD C, INVADER_WIDTH	; C = ١1Ĺ
CHECK_PLAYER_LOSE_INNER_LOOP:		
	LD A, (HL)
	CP 20h
	JR NZ, CHECK_PLAYER_LOSE_LINE; å
	INC HL
	DEC C
	JR NZ, CHECK_PLAYER_LOSE_INNER_LOOP
CHECK_PLAYER_LOSE_INNER_NEXT:	
	DEC E			; ١ƱΤδ
	DEC E
	DJNZ CHECK_PLAYER_LOSE_LOOP
	SCF
	CCF			; carry = 0
	RET
	
	;; ˤĤƥå
CHECK_PLAYER_LOSE_LINE:
	LD A, D
	SUB E
	CCF			; D = E ǤΩ
	RET C			; 桼餱
	;; ˥å
CHECK_PLAYER_LOSE_LINE_NEXT:	
	INC HL
	DEC C
	JR NZ, CHECK_PLAYER_LOSE_LINE_NEXT
	JR CHECK_PLAYER_LOSE_INNER_NEXT
	
;;; ----------------------------------------------------------------------
;;; check_crash_shot
;;;   ١ƴݤȽ
;;;   äƤ׻ޤ
;;; :	ʤ
;;; ----------------------------------------------------------------------
	
check_crash_shot:	
	;; ŨƴݤȽ
	LD A, (SHOT_Y)
	LD D, A			; D = ƴݤYɸ
	LD B, INVADER_TYPES
	LD A, (INVADER_Y)
	LD E, A			; E = ١Yɸ
CHECK_CRASH_SHOT_Y_CMP:		; ޤYɸ
	INC E			; ١ƱΤδ
	INC E
	LD A, D
	CP E
	JR Z, CHECK_CRASH_SHOT_X_CMP
	DJNZ CHECK_CRASH_SHOT_Y_CMP
	RET	;  Yɸפʤä
	
CHECK_CRASH_SHOT_X_CMP:
	LD A, INVADER_TYPES
	SUB B			; A = ١β 0~
	PUSH AF			; å
	LD HL, INVADERS_LINES
	JR Z, CHECK_CRASH_SHOT_X_CMP_INVADER
CHECK_CRASH_SHOT_X_CMP_Y_CALC:	
	LD DE, INVADER_WIDTH
	ADD HL, DE
	DEC A
	JR NZ, CHECK_CRASH_SHOT_X_CMP_Y_CALC
CHECK_CRASH_SHOT_X_CMP_INVADER:		; Xɸ
	LD A, (INVADER_X)
	LD B, A
	LD A, (SHOT_X)
	SUB B			; A = κüΥեå
	JR C, CHECK_CRASH_SHOT_X_CMP_INVADER_WRONG
	CP INVADER_WIDTH
	CCF			; üϤ߽Фʤ饢
	JR C, CHECK_CRASH_SHOT_X_CMP_INVADER_WRONG
	LD C, A			; C = κüΥեå
	;; ɤΥ١
	LD HL, INVADERS_LINES
	POP AF			; ܤ
	PUSH AF
	AND A
	JR Z, CHECK_CRASH_SHOT_X_CMP_INVADER_WHICH
CHECK_CRASH_SHOT_X_CMP_INVADER_CALC:	
	LD DE, INVADER_WIDTH
	ADD HL, DE
	DEC A
	JR NZ, CHECK_CRASH_SHOT_X_CMP_INVADER_CALC
CHECK_CRASH_SHOT_X_CMP_INVADER_WHICH:	
	LD B, 0
	ADD HL, BC		; HL = õƤ륤١ؤƤ
	LD A, (HL)
	CP 20h
	JR Z, CHECK_CRASH_SHOT_X_CMP_INVADER_WRONG	; 
	;; ١ (20hǾä)
	LD A, 20h
	LD (HL), A
	
	;; ꡪ
	LD A, (SHOT_Y)		; ƴݤɽ򥯥ꥢ
	LD E, A
	LD A, (SHOT_X)
	LD D, A
	call set_pos
	LD A, 20h
	call putchar
	XOR A			; ƴݥꥻå
	DEC A
	LD (SHOT_Y), A
	;;   
	LD HL, (CURRENT_POINT)
	LD DE, BASE_POINT	;  BASE_POINT * 鲿
	POP AF			; A = 夫鲿Ԥᤫ 0~
	LD B, INVADER_TYPES
	SUB B
	NEG			; A = 鲿 1~
CHECK_CRASH_POINT_CALC:	
	ADD HL, DE
	DEC A
	JR NZ, CHECK_CRASH_POINT_CALC
	LD (CURRENT_POINT), HL
	call display_point	; ɽ
	RET
	
CHECK_CRASH_SHOT_X_CMP_INVADER_WRONG:		
	POP AF			; ܤ ˴

	RET

;;; ----------------------------------------------------------------------
;;; display_point
;;;   ɽ
;;; ----------------------------------------------------------------------
display_point:
	;; 
	LD HL, DEFAULT_SCREEN_COLOR
	call puts
	;; ߤɽ
	LD HL, (CURRENT_POINT)
	LD DE, POINT_BUFFER
	call util_itoa
	LD D, 0
	LD E, 0			; ɽ
	call set_pos
	LD HL, POINT_MSG	; ʸϢ³Ƥ check
	call puts

	;; ǹɽ
	LD DE, SCREEN_WIDTH/2*100h + 0
	call set_pos
	LD HL, TOP_POINT_MSG
	call puts
	;; Ⱥǹ礭Ȥ
	LD HL, (RANKING_POINT)
	LD DE, (CURRENT_POINT)
	AND A			; carry = 0
	SBC HL, DE
	JR C, DISPLAY_POINT_TOP_POINT
	LD DE, (RANKING_POINT)
DISPLAY_POINT_TOP_POINT:	
	EX DE, HL
	LD DE, POINT_BUFFER
	call util_itoa
	LD HL, POINT_BUFFER
	call puts
	RET

;;; ----------------------------------------------------------------------
;;; ranking
;;;   󥭥
;;;   ǹʤ̾
;;; ----------------------------------------------------------------------
ranking:
	LD BC, (CURRENT_POINT)
	LD A, 5			; TOP 5
	LD HL, RANKING_POINT	; Ƭɥ쥹
RANKING_CHECK_LOOP:
	LD E, (HL)
	INC HL
	LD D, (HL)
	INC HL
	EX DE, HL		; HL = 󥭥󥰤
	AND A
	SBC HL, BC
	EX DE, HL		; HL = Υɥ쥹
	JR C, RANKING_RANKIN
	DEC A
	JR NZ, RANKING_CHECK_LOOP
	RET			; 󥭥󥰳

RANKING_RANKIN:
	;; A = 5-+1
	;; HL =  Υɥ쥹+2
	;; BC = ߤ
	PUSH AF			; åA
	PUSH BC			; å˸ߤ
	DEC HL
	DEC HL
RANKING_RANKIN_MOVING_POINT:	; ĤŤĤ餹
	POP DE			; DE = 1ν̤
	LD C, (HL)
	INC HL
	LD B, (HL)		; BC = ν̤
	DEC HL
	LD (HL), E
	INC HL
	LD (HL), D
	INC HL
	PUSH BC			; å
	DEC A
	JR NZ, RANKING_RANKIN_MOVING_POINT
	POP BC			; ǲ̤˴

RANKING_RANKIN_MOVING_NAME:	; ̾ĤŤĤ餹
	POP AF			; A = 5-+1
	PUSH AF
	LD HL, RANKING_NAME
	LD C, A
	SUB 5
	NEG
	AND A
	JR Z, RANKING_RANKIN_MOVING_NAME_LOOP_PRE
RANKING_RANKIN_MOVING_NAME_ADDR_LOOP:	; ɥ쥹׻
	INC HL
	INC HL
	DEC A
	JR NZ, RANKING_RANKIN_MOVING_NAME_ADDR_LOOP
RANKING_RANKIN_MOVING_NAME_LOOP_PRE:
	POP AF			; 
	PUSH HL			; å˥ץ졼䡼̾륢ɥ쥹
	PUSH HL			; å˥ߡ
RANKING_RANKIN_MOVING_NAME_LOOP:	; ̾ݥ󥿤ĤŤĤ餹
	POP DE			; DE = 1ν̤̾
	LD C, (HL)
	INC HL
	LD B, (HL)		; BC = ν̤̾
	DEC HL
	LD (HL), E
	INC HL
	LD (HL), D
	INC HL
	PUSH BC			; å
	DEC A
	JR NZ, RANKING_RANKIN_MOVING_NAME_LOOP

	;; ̾Ͽ
	LD HL, RANKING_INPUT_MSG
	call puts
	POP HL			; ǲ̤̾ݥ󥿤桼
	PUSH HL
	;; ̾Ͽ
	LD BC, RANKING_NAME_LEN+1	; ̾Ĺ+NULL
	call fgets
	POP DE			; ̾ݥ
	POP HL			; 񤭹ॢɥ쥹
	LD (HL), E
	INC HL
	LD (HL), D
	
	RET
	
;;; ----------------------------------------------------------------------
;;; display_ranking
;;;   󥭥󥰤ɽ
;;; ----------------------------------------------------------------------
display_ranking:
	;; 󥭥󥰥ȥ
	LD HL, RANKING_DISPLAY_MSG
	call puts
	
	;; ɸ
	LD D, 20		; X
	LD E, 10		; Y
	LD B, 5
	LD C, 0			; C = 
	LD IX, RANKING_POINT
	LD IY, RANKING_NAME
DISPLAY_RANKING_EACH:
	PUSH DE			; DE = XY
	PUSH BC			; BC = 
	call set_pos
	;;  ̾

	POP BC
	INC C
	PUSH BC
	LD A, C
	call util_i
	LD A, C
	call putchar
	LD HL, RANKING_DISPLAY_RANK
	call puts		; x 
	;; 
	LD L, (IX+0)
	INC IX
	LD H, (IX+0)		; DE = 
	INC IX
	LD DE, POINT_BUFFER
	call util_itoa
	LD HL, POINT_BUFFER
	call puts

	LD A, 20h
	call putchar
	;; ̾
	LD L, (IY+0)
	INC IY
	LD H, (IY+0)
	INC IY
	call puts
	
	POP BC
	POP DE
	INC E
	INC E
	DJNZ DISPLAY_RANKING_EACH
	
	RET
	
RANKING_DISPLAY_MSG:
	DB 1Bh, '[2J'		; ꥢ
	DB POS('20', '7'), 'ޤǤκǹ', NULL
RANKING_DISPLAY_RANK:
	DB ":  "
	
;;; ----------------------------------------------------------------------
;;; set_pos
;;;   ֤ΰư
;;;   DE ( D = X, E = Y)
;;; ˲ A BC HL
;;; ----------------------------------------------------------------------
set_pos:	
	LD A, E	
	call util_i
	LD A, B
	LD (INVADERS_POS_STRING_ROW), A
	LD A, C
	LD (INVADERS_POS_STRING_ROW+1), A
	LD A, D
	call util_i
	LD A, B
	LD (INVADERS_POS_STRING_COL), A
	LD A, C
	LD (INVADERS_POS_STRING_COL+1), A
	LD HL, INVADERS_POS_STRING
	call puts
	
	RET

;;; ----------------------------------------------------------------------
;;; ǡΰ
;;; ----------------------------------------------------------------------
	
	;; 
INVADER_LEVEL:
	DB 0
INVADER_TIMER:	/* ١Υߥ */
	DB 0
SHOT_TIMER:	/* ƴݤΥߥ */
	DB 0
INVADER_X:	/* 奤١Xɸ */
	DB 0
INVADER_Y:	/* 奤١Yɸ */
	DB 0
INVADER_TIMING: /* ١ΰưߥ ٤Ѥ */
	DB 0
	
	/* ƴݤΰ */
SHOT_X:	
	DB 0
SHOT_Y:	
	DB 0

	/* ˤΰ */
CANNON_X:	
	DB 0
	
	/* ߤ */
CURRENT_POINT:
	DW 0
	/* ȥå5 */
RANKING_POINT:	
	DW 0,0,0,0,0
	/* ȥå5̾ */
	/*   ݥȤ (ϥǥեȳ) */
RANKING_NAME:
	DW RANKING_NAME_BUFFER
	DW RANKING_NAME_BUFFER+ RANKING_NAME_LEN   + 1
	DW RANKING_NAME_BUFFER+ RANKING_NAME_LEN*2 + 2
	DW RANKING_NAME_BUFFER+ RANKING_NAME_LEN*3 + 3
	DW RANKING_NAME_BUFFER+ RANKING_NAME_LEN*4 + 4

	/* ̾Ĺ RANKING_NAME_LEN (NULL˺줺) */
RANKING_NAME_BUFFER:	
	DB "         "
	DB "         "
	DB "         "
	DB "         "
	DB "123456789"

TOP_POINT_MSG:
	DB "ǹ:  "
POINT_MSG:
	DB ': '		; '   :   '
	/* ľΥХåե */
POINT_BUFFER:
	DB 0, 0, 0, 0, 0, NULL
	
RANKING_INPUT_MSG:
	DB COLOR(COLOR_WHITE), COLOR(BGCOLOR_BLACK)
	DB POS('20', '10'), 'ǤȤ󥯥󤷤ޤ'
	DB POS('20', '12'), '̾ϤƲ'
	DB POS('20', '13'), "? "

	/* 迧 */		
DEFAULT_SCREEN_COLOR:
	DB COLOR(COLOR_WHITE), COLOR(BGCOLOR_BLACK), NULL
	/* ̾õο */
DEFAULT_SCREEN_ERASE_COLOR:
	DB COLOR(COLOR_BLACK), COLOR(BGCOLOR_BLACK), NULL

SCREEN_START_STRING:
	DB COLOR(COLOR_RED), COLOR(BGCOLOR_BLACK)
	DB ESC_CLS, ESC_NOECHO
	DB POS('20','10'), "INVADER"
		
	/* ŨΥǡ */
INVADERS_CHAR:	
	DB 'H', 'W', 'T'
INVADERS_COLOR:		/* Ũοindex */
	DW invaders_color1, invaders_color2, invaders_color3
INVADERS_COLOR1:	
	DB COLOR(COLOR_RED), NULL
INVADERS_COLOR2:	
	DB COLOR(COLOR_BLUE), NULL
INVADERS_COLOR3:
	DB COLOR(COLOR_GREEN), NULL

	/* ɸʸ */
INVADERS_POS_STRING:
	DB 1Bh, '['
INVADERS_POS_STRING_ROW:	
	DB 0,0, ';'
INVADERS_POS_STRING_COL:	
	DB 0,0, 'H', NULL

	/* ̥ꥢ */
SCREEN_CLEAR_STRING:
	DB COLOR(COLOR_WHITE), COLOR(BGCOLOR_BLACK), 1Bh, '[2J', NULL
	
	/* 1ı ʸ */
CURSOR_MOVE_RIGHT:	
	DB 1Bh, '[C', NULL

	/* ƴ */
SHOT_CHAR:	
	DB COLOR(COLOR_WATER), "0"
		
	/* ˤ դ */
CANNON_LINE1_COLOR:	
	DB COLOR(COLOR_WHITE)
CANNON_LINE1:	
	DB " U "
CANNON_LINE2:	
	DB COLOR(BGCOLOR_WHITE), 'HHH', COLOR(BGCOLOR_BLACK), NULL
CANNON_ERASE_LINE1:
	DB "   "
CANNON_ERASE_LINE2:
	DB "   "
	
	/* ץ졼䡼̤ɽ */
LOSER_MESSAGE:
	DB COLOR(COLOR_RED), COLOR(BGCOLOR_WHITE)
	DB POS('25','10')
	DB 'You Lose!'
	DB POS('25','12')
	DB "ha ha ha...", NULL
	
	/* ѥǡ */
	/*   ץν꤫ */
INVADERS_LINES:	
	DB 0

	/* ꤫餢Ȥϥǡΰ˻Ȥ */