/***************************************************************************
                          z80emulaterdoc.h  -  description
                             -------------------
    begin                :  10 16 20:27:21 JST 2001
    copyright            : (C) 2001 by zakki
    email                : zakki@peppermint.jp
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef Z80EMULATERDOC_H
#define Z80EMULATERDOC_H

// include files for QT
#include <qobject.h>
#include <qstring.h>
#include <vector>
#include <map>
#include "Z80.h"

using namespace std;

// application specific includes

/**
  * the Document Class
  */

class Z80emulaterDoc : public QObject
{
	Q_OBJECT

public:
	Z80emulaterDoc();
	~Z80emulaterDoc();
	void newDoc();
	bool save();
	bool saveAs(const QString &filename);
	bool load(const QString &filename);
	bool isModified() const;

	void WrZ80(register word Addr,register byte Value);
	byte RdZ80(register word Addr);
	void OutZ80(register word Port,register byte Value);
	byte InZ80(register word Port);
	void PatchZ80(register Z80 *R);
	word LoopZ80(register Z80 *R);
	
	Z80* getZ80();
	
	int getCurrentLineNo();
	QString getCurrentLine();
	
	vector<QString>& getCodes();
public slots:
	void slotRun(int cycle);
	void slotStep();
	void slotStop();
	void slotReset();
signals:
	void documentChanged();

protected:
	virtual void timerEvent(QTimerEvent* te);
	bool modified;
	int m_updateCycle;
	
	byte m_mem[0xffff];
	vector<QString> m_codes;

	int m_currentLine;

	map<int, int> m_addrToLine;
	
	Z80 m_z80;
};

#endif
