/***************************************************************************
                          z80emulaterview.h  -  description
                             -------------------
    begin                :  10 16 20:27:21 JST 2001
    copyright            : (C) 2001 by zakki
    email                : zakki@peppermint.jp
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef Z80EMULATERVIEW_H
#define Z80EMULATERVIEW_H

// include files for QT
#include <qwidget.h>
#include <qmultilineedit.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qcheckbox.h>

// application specific includes
#include "z80emulaterdoc.h"

/**
 * This class provides an incomplete base for your application view. 
 */

class Z80emulaterView : public QWidget
{
  Q_OBJECT
  public:
    Z80emulaterView(QWidget *parent=0, Z80emulaterDoc* doc=0);
    ~Z80emulaterView();
  
  public slots:
	void slotRun();
	void slotStep();
	void slotStop();
	void slotReset();
	
  protected slots:
    void slotDocumentChanged();

  private:
	Z80emulaterDoc* m_doc;
	QMultiLineEdit* m_asmCode;
	QLineEdit* m_AF;
	QLineEdit* m_BC;
	QLineEdit* m_DE;
	QLineEdit* m_HL;
	QLineEdit* m_IX;
	QLineEdit* m_IY;
	QLineEdit* m_PC;
	QLineEdit* m_SP;
	QLineEdit* m_AF1;
	QLineEdit* m_BC1;
	QLineEdit* m_DE1;
	QLineEdit* m_HL1;
	QLineEdit* m_IFF;
	QLineEdit* m_I;
	QLineEdit* m_CYCLE;
	
	QCheckBox* m_trace;
	QLineEdit* m_updateCount;
	
	QPushButton* m_run;
	QPushButton* m_step;
	QPushButton* m_stop;
	QPushButton* m_reset;
};

#endif
